/***************************************************************************
**                                                            
**                    Multi-LAB/2 Header-Datei fuer ML2DEB     
**                                                            
**                 Datum der Freigabe : 21.04.1994                   
**                              Autor : GR, MH, MIH
**                             Status : freigegeben                
**                                                                 
**                (c) SORCUS Computer GmbH 1994..1997 
***************************************************************************/

#ifndef _ML2DEB_H_
#define _ML2DEB_H_


#include "ml2bib.h"

#define HML2   unsigned short    /* 2 Byte, Handle fuer MultiLAB/2 */

/**************************************************************************
*  Kanal-Resourcen der Multi-LAB/2
**************************************************************************/

/*-------------------------------------------------------------------------
*  Definition analoger Single-Ended Eingnge [ad_channel]
*-------------------------------------------------------------------------*/
#define ML2_ASE_IN0     0x1000  /* 1. Single-Ended Eingang, AIN-0 */
#define ML2_ASE_IN1     0x1001  /* 2. Single-Ended Eingang, AIN-1 */
#define ML2_ASE_IN2     0x1002  /* 3. Single-Ended Eingang, AIN-2 */
#define ML2_ASE_IN3     0x1003  /* 4. Single-Ended Eingang, AIN-3 */
#define ML2_ASE_IN4     0x1004  /* 5. Single-Ended Eingang, AIN-4 */
#define ML2_ASE_IN5     0x1005  /* 6. Single-Ended Eingang, AIN-5 */
#define ML2_ASE_IN6     0x1006  /* 7. Single-Ended Eingang, AIN-6 */
#define ML2_ASE_IN7     0x1007  /* 8. Single-Ended Eingang, AIN-7 */
#define ML2_ASE_IN8     0x1008  /* 9. Single-Ended Eingang, AIN-8 */
#define ML2_ASE_IN9     0x1009  /* 10. Single-Ended Eingang, AIN-9 */
#define ML2_ASE_IN10    0x100A  /* 11. Single-Ended Eingang, AIN-10 */
#define ML2_ASE_IN11    0x100B  /* 12. Single-Ended Eingang, AIN-11 */
#define ML2_ASE_IN12    0x100C  /* 13. Single-Ended Eingang, AIN-12 */
#define ML2_ASE_IN13    0x100D  /* 14. Single-Ended Eingang, AIN-13 */
#define ML2_ASE_IN14    0x100E  /* 15. Single-Ended Eingang, AIN-14 */
#define ML2_ASE_IN15    0x100F  /* 16. Single-Ended Eingang, AIN-15 */
#define ML2_AD_GNDM     0x1010   /* Ground am Eingang der Karte */
#define ML2_AD_GNDA     0x1011   /* Ground am Eingang des ADC */
#define ML2_AD_VREF     0x1012   /* 5 Volt Referenzspannung des Moduls */
#define ML2_AD_DA0      0x1013   /* Ist-Wert Ausgang AOUT-0 */
#define ML2_AD_DA1      0x1014   /* Ist-Wert Ausgang AOUT-1 */
#define ML2_AD_TMP_ADC     0xC015   /* Temperaturwert am ADC */
#define ML2_AD_VNREF    0x1017   /* -5 Volt Referenzspannung des Moduls */

/*-------------------------------------------------------------------------
*  Definition analoger Differenzeingnge [ad_channel]
*-------------------------------------------------------------------------*/
#define ML2_ADIF_IN0    0x2000  /* 1. Differenzeingang, AIN-0 - AIN-8 */
#define ML2_ADIF_IN1    0x2001  /* 2. Differenzeingang, AIN-1 - AIN-9 */
#define ML2_ADIF_IN2    0x2002  /* 3. Differenzeingang, AIN-2 - AIN-10 */
#define ML2_ADIF_IN3    0x2003  /* 4. Differenzeingang, AIN-3 - AIN-11 */
#define ML2_ADIF_IN4    0x2004  /* 5. Differenzeingang, AIN-4 - AIN-12 */
#define ML2_ADIF_IN5    0x2005  /* 6. Differenzeingang, AIN-5 - AIN-13 */
#define ML2_ADIF_IN6    0x2006  /* 7. Differenzeingang, AIN-6 - AIN-14 */
#define ML2_ADIF_IN7    0x2007  /* 8. Differenzeingang, AIN-7 - AIN-15 */

/*-------------------------------------------------------------------------
*  Definition analoger Ausgnge [da_channel]
*-------------------------------------------------------------------------*/
#define ML2_DA_0     0x3000   /* 1. analoger Ausgang, AOUT-0 */
#define ML2_DA_1     0x3001   /* 2. analoger Ausgang, AOUT-1 */

/*-------------------------------------------------------------------------
*  Definition digitaler Eingnge [ip_channel]
*-------------------------------------------------------------------------*/
#define ML2_IP_0     0x4000   /* 1. digitaler Eingang, DIN-0 */
#define ML2_IP_1     0x4001   /* 2. digitaler Eingang, DIN-1 */
#define ML2_IP_2     0x4002   /* 3. digitaler Eingang, DIN-2 */
#define ML2_IP_3     0x4003   /* 4. digitaler Eingang, DIN-3 */
#define ML2_IP_4     0x4004   /* 5. digitaler Eingang, DIN-4 */
#define ML2_IP_5     0x4005   /* 6. digitaler Eingang, DIN-5 */
#define ML2_IP_6     0x4006   /* 7. digitaler Eingang, DIN-6 */
#define ML2_IP_7     0x4007   /* 8. digitaler Eingang, DIN-7 */
#define ML2_IP_8     0x4008   /* 9. digitaler Eingang, DIN-8 */
#define ML2_IP_9     0x4009   /* 10. digitaler Eingang, DIN-9 */
#define ML2_IP_10    0x400A   /* 11. digitaler Eingang, DIN-10 */
#define ML2_IP_11    0x400B   /* 12. digitaler Eingang, DIN-11 */
#define ML2_IP_12    0x400C   /* 13. digitaler Eingang, DIN-12 */
#define ML2_IP_13    0x400D   /* 14. digitaler Eingang, DIN-13 */
#define ML2_IP_14    0x400E   /* 15. digitaler Eingang, DIN-14 */
#define ML2_IP_15    0x400F   /* 16. digitaler Eingang, DIN-15 */
#define ML2_IP_ALL      0x4FFF   /* Alle digitalen Eingnge lesen */

/*-------------------------------------------------------------------------
*  Definition digitaler Ausgnge [op_channel]
*-------------------------------------------------------------------------*/
#define ML2_OP_0     0x5000   /* 1. digitaler Ausgang, DOUT-0 */
#define ML2_OP_1     0x5001   /* 2. digitaler Ausgang, DOUT-1 */
#define ML2_OP_2     0x5002   /* 3. digitaler Ausgang, DOUT-2 */
#define ML2_OP_3     0x5003   /* 4. digitaler Ausgang, DOUT-3 */
#define ML2_OP_4     0x5004   /* 5. digitaler Ausgang, DOUT-4 */
#define ML2_OP_5     0x5005   /* 6. digitaler Ausgang, DOUT-5 */
#define ML2_OP_6     0x5006   /* 7. digitaler Ausgang, DOUT-6 */
#define ML2_OP_7     0x5007   /* 8. digitaler Ausgang, DOUT-7 */
#define ML2_OP_ALL      0x5FFF   /* Alle digitaler Ausgnge setzen */

/*-------------------------------------------------------------------------
*  Definition der Interruptkanle [irq_channel]
*-------------------------------------------------------------------------*/
#define ML2_IRQ_CHANNEL_3  0x6003   /* Interrupt-Kanal 3 */
#define ML2_IRQ_CHANNEL_5  0x6005   /* Interrupt-Kanal 5 */
#define ML2_IRQ_CHANNEL_9  0x6009   /* Interrupt-Kanal 9 */
#define ML2_IRQ_CHANNEL_10 0x600A   /* Interrupt-Kanal 10 */
#define ML2_IRQ_CHANNEL_11 0x600B   /* Interrupt-Kanal 11 */
#define ML2_IRQ_CHANNEL_12 0x600C   /* Interrupt-Kanal 12 */
#define ML2_IRQ_CHANNEL_15 0x600F   /* Interrupt-Kanal 15 */

/*-------------------------------------------------------------------------
*  Definition der DMA-Kanle [dma_channel]
*-------------------------------------------------------------------------*/
#define ML2_DMA_CHANNEL_0  0x7000   /* DMA-Kanal 0 */
#define ML2_DMA_CHANNEL_1  0x7001   /* DMA-Kanal 1 */
#define ML2_DMA_CHANNEL_3  0x7003   /* DMA-Kanal 3 */

/*-------------------------------------------------------------------------
*  Definition der Ereignis-Kanle [events_channel]
*-------------------------------------------------------------------------*/
#define ML2_EVENTS_IP8     0x8000   /* Ereignis-Kanal 0 */
#define ML2_EVENTS_IP9     0x8001   /* Ereignis-Kanal 1 */
#define ML2_EVENTS_IP10    0x8002   /* Ereignis-Kanal 2 */
#define ML2_EVENTS_IP11    0x8003   /* Ereignis-Kanal 3 */
#define ML2_EVENTS_IP12    0x8004   /* Ereignis-Kanal 4 */
#define ML2_EVENTS_IP13    0x8005   /* Ereignis-Kanal 5 */
#define ML2_EVENTS_IP14    0x8006   /* Ereignis-Kanal 6 */
#define ML2_EVENTS_IP15    0x8007   /* Ereignis-Kanal 7 */

/*-------------------------------------------------------------------------
*  Definition der Frequenzmessungs-Kanle [frequency_channel]
*-------------------------------------------------------------------------*/
#define ML2_FREQUENCY_IP8  0x9000   /* Frequenzmessungs-Kanal 0 */
#define ML2_FREQUENCY_IP9  0x9001   /* Frequenzmessungs-Kanal 1 */
#define ML2_FREQUENCY_IP10 0x9002   /* Frequenzmessungs-Kanal 2 */
#define ML2_FREQUENCY_IP11 0x9003   /* Frequenzmessungs-Kanal 3 */
#define ML2_FREQUENCY_IP12 0x9004   /* Frequenzmessungs-Kanal 4 */
#define ML2_FREQUENCY_IP13 0x9005   /* Frequenzmessungs-Kanal 5 */
#define ML2_FREQUENCY_IP14 0x9006   /* Frequenzmessungs-Kanal 6 */
#define ML2_FREQUENCY_IP15 0x9007   /* Frequenzmessungs-Kanal 7 */

/*-------------------------------------------------------------------------
*  Definition der Pulsbreitenmessungs-Kanle [pulsewidth_channel]
*-------------------------------------------------------------------------*/
#define ML2_PULSEWIDTH_IP8 0xA000   /* Pulsbreitenmessung-Kanal 0 */
#define ML2_PULSEWIDTH_IP9 0xA001   /* Pulsbreitenmessung-Kanal 1 */
#define ML2_PULSEWIDTH_IP10   0xA002   /* Pulsbreitenmessung-Kanal 2 */
#define ML2_PULSEWIDTH_IP11   0xA003   /* Pulsbreitenmessung-Kanal 3 */
#define ML2_PULSEWIDTH_IP12   0xA004   /* Pulsbreitenmessung-Kanal 4 */
#define ML2_PULSEWIDTH_IP13   0xA005   /* Pulsbreitenmessung-Kanal 5 */
#define ML2_PULSEWIDTH_IP14   0xA006   /* Pulsbreitenmessung-Kanal 6 */
#define ML2_PULSEWIDTH_IP15   0xA007   /* Pulsbreitenmessung-Kanal 7 */

/*-------------------------------------------------------------------------
*  Definition der Periodenmessungs-Kanle [period_channel]
*-------------------------------------------------------------------------*/
#define ML2_PERIOD_IP8     0xB000   /* Periodenmessung-Kanal 0 */
#define ML2_PERIOD_IP9     0xB001   /* Periodenmessung-Kanal 1 */
#define ML2_PERIOD_IP10    0xB002   /* Periodenmessung-Kanal 2 */
#define ML2_PERIOD_IP11    0xB003   /* Periodenmessung-Kanal 3 */
#define ML2_PERIOD_IP12    0xB004   /* Periodenmessung-Kanal 4 */
#define ML2_PERIOD_IP13    0xB005  /* Periodenmessung-Kanal 5 */
#define ML2_PERIOD_IP14    0xB006   /* Periodenmessung-Kanal 6 */
#define ML2_PERIOD_IP15    0xB007   /* Periodenmessung-Kanal 7 */

/**************************************************************************
*  Einstellungen (flags), die zustzlich zu der Kanal-Resource angegeben
*  werden knnen.
**************************************************************************/

/*-------------------------------------------------------------------------
*  Definition von 'Autoinkrement' [increment]
*  In der Betriebsart Autoinkrement wird der Eingangsmultiplexer
*  automatisch nach einer Wandlung auf den nchsten Kanal eingestellt.
*  Kann fr ML2_ASE_IN0 bis ML2_ASE_IN15 und fr ML2_ADIF_IN0 bis
*  ML2_ADIF_IN8 verwendet werden.
*-------------------------------------------------------------------------*/
#define ML2_NON_AUTO_INCREMENT   0x0000   /* Autoinkrement wird nicht verwendet */
#define ML2_AUTO_INCREMENT 0x0001   /* Autoinkrement eingeschaltet */

/*-------------------------------------------------------------------------
*  Definition der Updatekonstante [update]
*  Nach dem Beschreiben des DA Bausteins kann der Wert gepuffert oder
*  in die Ausgangsregister bernommen werden. Diese Einstellung kann
*  fr die analogen Ausgnge ML2_DA_0 und ML2_DA_1 verwendet werden.
*-------------------------------------------------------------------------*/
#define ML2_DA_NON_UPDATE  0x0000   /* Ausgang wird beim Beschreiben
                  gepuffert. */
#define ML2_DA_UPDATE      0x0001   /* Ausgang wird beim Beschreiben in
                  die Ausgangsregister bernommen. */

/*-------------------------------------------------------------------------
*  Definition der Spannungs Bereiche [voltage]
*-------------------------------------------------------------------------*/
#define ML2_UPP_625mV      0x0100   /* Unipolar von 0 bis 625 mV */
#define ML2_UPP_1_25V      0x0200   /* Unipolar von 0 bis 1,25 V */
#define ML2_UPP_2_5V    0x0300   /* Unipolar von 0 bis 2,5 V */
#define ML2_UPP_5V      0x0400   /* Unipolar von 0 bis 5 V */
#define ML2_UPP_10V     0x0500   /* Unipolar von 0 bis 10 mV */
#define ML2_UPN_625mV      0x0600   /* Unipolar von 0 bis -625 mV */
#define ML2_UPN_1_25V      0x0700   /* Unipolar von 0 bis -1,25 V */
#define ML2_UPN_2_5V    0x0800   /* Unipolar von 0 bis -2,5 V */
#define ML2_UPN_5V      0x0900   /* Unipolar von 0 bis -5 V */
#define ML2_UPN_10V     0x0A00   /* Unipolar von 0 bis -10 V */
#define ML2_BP_312_5mV     0x0B00   /* Bipolar +/- 312,5 mV */
#define ML2_BP_625mV    0x0C00   /* Bipolar +/- 625 mV */
#define ML2_BP_1_25V    0x0D00   /* Bipolar +/- 1,25 V */
#define ML2_BP_2_5V     0x0E00   /* Bipolar +/- 2,5 V */
#define ML2_BP_5V    0x0F00   /* Bipolar +/- 5 V */
#define ML2_BP_10V      0x1000   /* Bipolar +/- 10 V */
#define ML2_BP_20V      0x1100   /* Bipolar +/- 20 V */

/*-------------------------------------------------------------------------
*  Definition der Strom Bereiche [ampere]
*-------------------------------------------------------------------------*/
#define ML2_UP_0_TO_20mA   0x1200   /* Unipolar von 0 bis 20 mA */
#define ML2_UP_4_TO_20mA   0x1300   /* Unipolar von 4 bis 20 mA */

/*-------------------------------------------------------------------------
*  Definition der Latch-Konstante [latch]
*     Wird dieses Flag angegeben, so werden vor dem Lesen der Eingnge
*  ML2_IP_0 bis ML2_IP_15 und ML2_IP_ALL alle Eingnge gelatched.
*-------------------------------------------------------------------------*/
#define ML2_NON_LATCH      0x0000   /* Beim Lesen von dem Port wird kein
                  Latch-Befehl vorausgeschickt. */
#define ML2_SW_LATCH            0x0001 /* Die Eingnge werden vor dem lesen
                  per Software gelatched */
#define ML2_HW_LATCH    0x0002  /* Die Eingnge werden durch einen
                  externen Trigger gelatched
                  Nur fr ML2_IP_0 */
#define ML2_NON_HW_LATCH   0x0004  /* Das externe Triggern wird dadurch
                  wieder unterbunden */

/*-------------------------------------------------------------------------
*  Definition der externen Latch-Flanke [edge]
*  Nur fr ML2_IP_0, ML2_EVENTS_IP8 bis ML2_EVENTS_IP15 und
*  ML2_PULSEWIDTH_IP8 bis ML2_PULSEWIDTH_IP15 einstellbar
*-------------------------------------------------------------------------*/
#define ML2_POS_EDGE    0x0000   /* Positive Flanke */
#define ML2_NEG_EDGE    0x0008   /* Negative Flanke */

/*-------------------------------------------------------------------------
*  Definition fr digitale Ausgnge freigeben [op_enable]
*  Diese Einstellung gilt fr alle digitalen Ausgngen und kann
*  daher nur mit der Kanal-Konstante ML2_OP_ALL kombiniert werden.
*-------------------------------------------------------------------------*/
#define ML2_OP_DISABLE     0x0001   /* Alle Ausgnge in den Tri-State
                  Zustand schalten */
#define ML2_OP_ENABLE      0x0002   /* Alle Ausgnge freigeben */

/*-------------------------------------------------------------------------
*  Definition der DMA-Richtung [dma_direction]
*-------------------------------------------------------------------------*/
#define ML2_DMA_ML2_PC        0x0000   /* DMA-Richtung ML2 -> PC */
#define ML2_DMA_PC_ML2        0x0008   /* DMA-Richtung PC -> ML2 */

/*-------------------------------------------------------------------------
*  Definition der Freigabe des DMA-Betriebs [dma_enable]
*-------------------------------------------------------------------------*/
#define ML2_DMA_DISABLE    0x0001  /* DMA-Kanal sperren */
#define ML2_DMA_ENABLE     0x0002  /* DMA-Kanal freigeben */

/*-------------------------------------------------------------------------
*  Definition der Hardwareverbindung Multi-LAB/2 <-> PC [dma_connect]
*-------------------------------------------------------------------------*/
#define ML2_DMA_DISCONNECT 0x0000   /* Physikalische Verbindung von
                  Multi-LAB/2 und PC trennen */
#define ML2_DMA_CONNECT    0x0004   /* Physikalische Verbindung von
                  Multi-LAB/2 und PC herstellen */

/*-------------------------------------------------------------------------
*  Definition der Freigabe des IRQ-Betriebs [irq_enable]
*-------------------------------------------------------------------------*/
#define ML2_IRQ_DISABLE    0x0001  /* IRQ-Kanal sperren */
#define ML2_IRQ_ENABLE     0x0002  /* IRQ-Kanal freigeben */

/*-------------------------------------------------------------------------
*  Definition der Hardwareverbindung Multi-LAB/2 <-> PC [irq_connect]
*-------------------------------------------------------------------------*/
#define ML2_IRQ_DISCONNECT 0x0000   /* Physikalische Verbindung von
                  Multi-LAB/2 und PC trennen */
#define ML2_IRQ_CONNECT    0x0004   /* Physikalische Verbindung von
                  Multi-LAB/2 und PC herstellen */

/*-------------------------------------------------------------------------
*  Definition des Counter-Reset [counter_reset]
*-------------------------------------------------------------------------*/
#define ML2_COUNTER_RESET  0x0010   /* Beim ffnen wird der Zhler auf
                  Null gesetzt. */

/*-------------------------------------------------------------------------
*  Definition des Gate-Eingangs [gate_in]
*-------------------------------------------------------------------------*/
#define ML2_GATE_TIMER_A   0x0000   /* Es wird die Torzeit vom Timer A
                  verwendet */
#define ML2_GATE_IP2    0x0020   /* Die Torzeit wird extern vom
                  Eingang IP-2 vorgegebene. */

/*-------------------------------------------------------------------------
*  Definition Auto-Wait fr
*     Frequenzmessung, Pulsbreitenmessung und Periodenmessung
*-------------------------------------------------------------------------*/
#define ML2_NON_AUTO_WAIT  0x0000   /* Ohne Auto-Wait fr Messungen */
#define ML2_AUTO_WAIT      0x0040   /* Auto-Wait fr Messungen */

/*-------------------------------------------------------------------------
*  Definition der Interrupts im Interrupt-Controller
*-------------------------------------------------------------------------*/
#define  ML2_IRQ_IP_0      0x01  /* IP-0 */
#define  ML2_IRQ_IP_2      0x02  /* IP-2 */
#define  ML2_IRQ_RBF    0x04  /* RBF */
#define  ML2_IRQ_TIMER_A      0x08  /* Timer-A */
#define  ML2_IRQ_TIMER_B_OVER 0x10  /* Timer-B, Overflow bzw. Timer-Interrupts */
#define  ML2_IRQ_TIMER_B      0x20  /* Timer-B, Messung beendet bzw. Inkr. Douwn */
               /* Counter Overflow */

/**************************************************************************
*  Einstellungen (ch_flag), die durch die Funktionen
*  ml2_change_channel_parameter und ml2_get_channel_parameter
*  verarbeitet werden knnen
**************************************************************************/
#define ML2_CHANGE_ALL_FLAGS     0xFFFFFFFF  /* Alle Flags */
#define ML2_CHANGE_AUTO_INCREMENT   0x80000001  /* Maske fr Autoinkrement */
#define ML2_CHANGE_DA_UPDATE     0x80000001  /* Maske fr DA Ausgangsregister bernommen. */
#define ML2_CHANGE_RANGE      0x8000FF00  /* Maske fr Strom/Spannungsbereiche */
#define ML2_CHANGE_LATCH      0x80000007     /* Maske fr latchen */
#define ML2_CHANGE_EDGE       0x80000008  /* Maske fr pos/neg Flanke */
#define ML2_CHANGE_OP_PORT    0x80000003  /* Maske fr OP Alle Ausgnge freigeben/sperren */
#define ML2_CHANGE_DMA_DIRECTION    0x80000008  /* Maske fr DMA-Richtung */
#define ML2_CHANGE_DMA_CONNECTION   0x80000004  /* Maske fr Physikalische Verbindung Multi-LAB/2 und PC */
#define ML2_CHANGE_DMA_PORT      0x80000003     /* Maske fr DMA-Kanal freigeben/sperren */
#define ML2_CHANGE_IRQ_DIRECTION    0x80000008  /* Maske fr IRQ-Richtung */
#define ML2_CHANGE_IRQ_CONNECTION   0x80000004  /* Maske fr Physikalische Verbindung Multi-LAB/2 und PC */
#define ML2_CHANGE_IRQ_PORT      0x80000003     /* Maske fr IRQ-Kanal freigeben/sperren */
#define ML2_CHANGE_AUTO_WAIT     0x80000040  /* Maske fr Auto-Wait fr Messungen */

/**************************************************************************
*  Definitionen fr Aktionen
***************************************************************************/
#define ML2_START_ACTION   0x0000      /* Aktion starten */
#define ML2_STOP_ACTION    0x0001      /* Aktion anhalten */
#define ML2_GET_ACTION_STATE  0x0002      /* Aktion Status ermitteln */


/**************************************************************************
****************** Funktionsaufrufe der PC Bibliothek *********************
***************************************************************************/

#if defined(__cplusplus)      /* C++ Switch im Compiler */
extern "C" {
#endif

/**************************************************************************
*  Diese Funktion ffnet den angegebenen Kanal 'channel' mit den
*  Eigenschaften 'flags'. Konnte der Kanal erfolgreich geffnet werden,
*  so wird ein Handle (Zugriffsverweis) ungleich Null zurckgeliefert.
*  Bei einem Fehler (Handle = 0) wird in 'error' eine Fehlernummer
*  zurckgegeben.
*  Parameter:
*     cardnumber: Kartennummer der MultiLAB/2
*     channel: Kanalnummer, physikalischer I/O Kanal
*               flags:     Zustzliche Kanaleigenschaften mit angeben
*
*        Analoge Eingnge:    channel = [ad_channel]
*                   flags   = [voltage][increment]
*        Analoge Ausgnge:    channel = [da_channel]
*                   flags   = [voltage][update]
*        Digtiale Eingnge:   channel = [ip_channel]
*                   flags   = [latch]
*                   flags   = [latch[edge]] Nur fr ML2_IP_0, Hardware-Latch
*        Digitale Ausgnge:   channel = [op_channel]
*                   flags   = [op_enable] Nur fr ML2_OP_ALL
*        DMA-Kanal:           channel = [dma_channel]
*                   flags   = [dma_direction][dma_enable][dma_connect]
*        IRQ-Kanal:           channel = [irq_channel]
*                   flags   = [irq_direction][irq_enable][irq_connect]
*
*     error:      Konnte der angeforderte Kanal nicht geffnet werden
*           (Handle=0), so wird in error die dazugehrige
*           Fehlernummer zurckgeliefert.
*
*  Rckgabeparameter:
*                HML2:     Ist dieser Wert ungleich Null, so konnte
*           der angeforderte Kanal erfolgreich geffnet
*           werden. Dieses Handle erlaubt ein schnelles
*           und einfaches Zugreifen auf das geffnete
*           Hardware-Device.
***************************************************************************/
ML10API HML2 MLXEXPORT ml2_open_channel( ushort cardnumber, ushort channel,
                 ulong flags, ushort *error );

/**************************************************************************
*  Diese Funktion schliet den geffneten Kanal. Das Handle wird
*  dadurch ungltig und darf nicht mehr verwendet werden.
*  Parameter:
*     handle:     Gltiger I/O Handle, das mit der Funktion
*           ml2_open_channel geffnet wurde
**************************************************************************/
ML10API void MLXEXPORT ml2_close_channel( HML2 handle );

/**************************************************************************
*  Mit der folgenden Funktion werden die physikalischen Ausgnge, die
*  durch 'handle' reprsentiert werden mit dem Wert 'data' beschrieben.
*     handle:     Gltiger I/O Handle, das mit der Funktion
*           ml2_open_channel geffnet wurde
*     data:    Wert, der auf das Ausgabedevice geschrieben
*           wird.
**************************************************************************/
ML10API void MLXEXPORT ml2_set_data( HML2 handle, short data );

/**************************************************************************
*  Mit der folgende Funktion werden die physikalischen Eingnge, die
*  durch 'handle' reprsentiert werden zurckgelesen.
*     handle:     Gltiger I/O Handle, das mit der Funktion
*           ml2_open_channel geffnet wurde
*
*  Rckgabeparameter:
*     data:    Wert, der von dem  Eingabedevice gelesen wird.
**************************************************************************/
ML10API short MLXEXPORT ml2_get_data( HML2 handle );

/**************************************************************************
*  Die Prozedur nderert die Eigenschaften des Kanals 'handle', die
*  zuvor mit der Funktion 'ml2_open_channel' festgelegt wurden.
*     handle:     Gltiger I/O Handle, das mit der Funktion
*           ml2_open_channel geffnet wurde
*     ch_flag: Einstellung die gendert werden soll
*             flags:    Kanaleigenschaften des Kanals
**************************************************************************/
ML10API void MLXEXPORT ml2_change_channel_parameter( HML2 handle,
                   ulong ch_flag,
                   ulong flags );

/**************************************************************************
*  Die Funktion liest die eingestelltem Eigenschaften des Kanals
*  'handle' zurck.
*     handle:     Gltiger I/O Handle, das mit der Funktion
*           ml2_open_channel geffnet wurde
*     ch_flag: Einstellung die gelesen werden soll
*
*  Rckgabeparameter:
*             flags:    Kanaleigenschaften des Kanals
**************************************************************************/
ML10API ulong MLXEXPORT ml2_get_channel_parameter( HML2 handle,
                      ulong ch_flag );

/**************************************************************************
*  Die Funktion liet den Status der Messung zurck
*     handle:     Gltiger I/O Handle, das mit der Funktion
*           ml2_open_channel geffnet wurde
**************************************************************************/
ML10API byte MLXEXPORT ml2_get_device_state( HML2 handle );


/**************************************************************************
*  Die Funktion setzt die Korrekturwerte 'gain' (Verstrkung) und
*  'offset' (Verschiebung) fr den Kanal, der durch 'handle'
*  reprsentiert wird.
*     handle:     Gltiger I/O Handle, das mit der Funktion
*           ml2_open_channel geffnet wurde.
*     gain:    Verstrkungs-Korrekturwert
*     offste:     Offset-Korrekturwert
**************************************************************************/
ML10API void MLXEXPORT ml2_set_correction( HML2 handle, ushort gain, ushort offset );


/**************************************************************************
*  Die Funktion liest die Korrekturwerte 'gain' (Verstrkung) und
*  'offset' (Verschiebung) fr den Kanal, der durch 'handle'
*  reprsentiert wird zurck.
*     handle:     Gltiger I/O Handle, das mit der Funktion
*           ml2_open_channel geffnet wurde.
*     gain:    gelesener Verstrkungs-Korrekturwert
*     offste:     gelesener Offset-Korrekturwert
**************************************************************************/
ML10API void MLXEXPORT ml2_get_correction( HML2 handle, ushort *gain, ushort *offset );


/***************************************************************************
*  Die Funktion berechnet aus den bergebenen Werten 'set_value_1'
*  (Soll-Wert 1), 'true_value_1' (Ist Wert 1) ,'set_value_2' und
*     'true_value_2' die Korrekturwerte fr den Kanal, der durch 'handle'
*  reprsentiert wird.
*     handle:     Gltiger I/O Handle, das mit der Funktion
*           ml2_open_channel geffnet wurde.
*     set_value_1:   1. Soll-Wert
*     true_value_1   Gemessener Ist-Wert zu Soll-Wert 1
*     set_value_2:   2. Soll-Wert
*     true_value_2   Gemessener Ist-Wert zu Soll-Wert 2
*************************************************************************/
ML10API void MLXEXPORT ml2_calculate_correction( HML2 handle, ushort set_value_1,
      ushort true_value_1, ushort set_value_2, ushort true_value_2 );

/**************************************************************************
*  Die Funktion setzt die die Settle-Time fr den Kanal,
*       der durch 'handle' reprsentiert wird.
*     handle:     Gltiger I/O Handle, das mit der Funktion
*           ml2_open_channel geffnet wurde.
*     settle:     Settle-Time
**************************************************************************/
ML10API void MLXEXPORT ml2_set_settletime( HML2 handle, ushort settletime );

/**************************************************************************
*  Die Funktion liest die Settle-Time fr den Kanal, der durch 'handle'
*  reprsentiert wird zurck.
*     handle:     Gltiger I/O Handle, das mit der Funktion
*           ml2_open_channel geffnet wurde.
*     settletime:     gelesene Settle-Time
**************************************************************************/
ML10API void MLXEXPORT ml2_get_settletime( HML2 handle, ushort *settletime );


/***************************************************************************
*      Die Funktion liefert die aktuelle Version der ML2-Device-Bibliothek
*       version: Versionsstring (Speicher mu vom Anwender
*        reserviert werden)
**************************************************************************/
ML10API void MLXEXPORT ml2_get_deb_version(char *version);

#if defined(__cplusplus)
} /*  Blockende von extern "C" */
#endif

#endif
