{********************************************************************
*  This is the implementation source file to build the libraries
*  for following platforms:
*
*  Board:               ML2 - Multi-LAB/2
*
*  Operating Systems:   Windows 95
*                       Windows NT
*
*  Author:              Dipl.-Ing. H.Doersam
*
*  Last Change:         21/07/98
*
*  Copyrights           SORCUS Computer GmbH 1997, 1998
*                       All rights reserved
*
********************************************************************}



{ ***** STARTING/ENDING OF AN APPLICATION ***** }

PROCEDURE   ml2_bib_startup
            (language: WORD);
            EXTERNAL DLL_REF NAME 'ml8_bib_startup';

FUNCTION    Cml2_reset
            (card, adr, mode, IRQ_channel, DMA_channel: WORD;
            error_handler: POINTER; OSName: PChar; timeout: WORD):
            WORD;
            EXTERNAL DLL_REF NAME 'ml2_reset';

FUNCTION    ml2_reset
            (card, adr, mode, IRQ_channel, DMA_channel: WORD;
            error_handler: POINTER; VAR OSName: str80;
            timeout: WORD): WORD;
VAR   OsX   :  ARRAY [0..80] OF CHAR;
BEGIN
   ml_cstr(OsX, OSName, 80);
   ml2_reset := Cml2_reset
      (card, adr, mode, IRQ_channel, DMA_channel,
      error_handler, OsX, timeout);
END;

FUNCTION    ml2_start
            (card, adr, mode, IRQ_channel, DMA_channel: WORD;
            error_handler: POINTER; timeout: WORD): WORD;
            EXTERNAL DLL_REF;

PROCEDURE   ml2_exit;
            EXTERNAL DLL_REF NAME 'ml8_exit';

PROCEDURE   ml2_exit_card
            (card: WORD);
            EXTERNAL DLL_REF NAME 'ml8_exit_card';

{ ***** VERSION MANAGEMENT ***** }

PROCEDURE   Cml2_get_bib_version
            (version: PChar);
            EXTERNAL DLL_REF NAME 'ml8_get_bib_version';

PROCEDURE   ml2_get_bib_version
            (VAR version: str80);
VAR ver: ARRAY [0..80] OF CHAR;
BEGIN
   Cml2_get_bib_version(ver);
   ml_pstr(version, ver, 80);
END;

PROCEDURE   Cml2_get_os_version
            (version: PChar);
            EXTERNAL DLL_REF NAME 'ml8_get_os_version';

PROCEDURE   ml2_get_os_version
            (VAR version: str80);
VAR ver: ARRAY [0..80] OF CHAR;
BEGIN
   Cml2_get_os_version(ver);
   ml_pstr(version, ver, 80);
END;

PROCEDURE   ml2_get_lib_version
            (VAR pulVersion: LONGINT; VAR pulDate: LONGINT);
            EXTERNAL DLL_REF NAME 'ml8_get_lib_version';

PROCEDURE   ml2_get_mlxdrv_version
            (VAR pulVersion: LONGINT; VAR pulDate: LONGINT);
            EXTERNAL DLL_REF NAME 'ml8_get_mlxdrv_version';

PROCEDURE   ml2_get_osx_version
            (VAR pulVersion: LONGINT; VAR pulDate: LONGINT);
            EXTERNAL DLL_REF NAME 'ml8_get_osx_version';

{ ***** CARD SELECTION ***** }

PROCEDURE   ml2_select_card
            (card: WORD);
            EXTERNAL DLL_REF NAME 'ml8_select_card';

FUNCTION    ml2_get_selected_card: WORD;
            EXTERNAL DLL_REF NAME 'ml8_get_selected_card';

{ ***** CARD CHECK ***** }

PROCEDURE   ml2_card_check
            (VAR b1: BYTE; VAR b2: BYTE; VAR b3: BYTE);
            EXTERNAL DLL_REF;

PROCEDURE   ml2_ga_version
            (VAR ic14, ic16, ic21: BYTE);
            EXTERNAL DLL_REF;

{ ***** TIMEOUT CONTROL ***** }

PROCEDURE   ml2_auto_timeout;
            EXTERNAL DLL_REF NAME 'ml8_auto_timeout';

FUNCTION    ml2_propose_timeout
            (tenthsec: WORD): WORD;
            EXTERNAL DLL_REF NAME 'ml8_propose_timeout';
{
PROCEDURE   ml2_set_timeout
            (timeout: WORD);
            EXTERNAL DLL_REF NAME 'ml8_set_timeout';
}
PROCEDURE   ml2_change_timeout
            (timeout: WORD);
            EXTERNAL DLL_REF NAME 'ml8_change_timeout';

FUNCTION    ml2_get_timeout: WORD;
            EXTERNAL DLL_REF NAME 'ml8_get_timeout';

{ ***** INSTALLING REAL TIME PROGRAMS ***** }

FUNCTION    Cml2_transfer_and_install
            (pgmname: PChar; usage, task, programnr,
            interruptnr: WORD; flag, datasize: LONGINT): WORD;
            EXTERNAL DLL_REF NAME 'ml8_transfer_and_install';

FUNCTION    ml2_transfer_and_install
            (pgmname: str80; usage, task, programnr,
            interruptnr: WORD; flag, datasize: LONGINT): WORD;
VAR   pgm   :  ARRAY [0..80] OF CHAR;
BEGIN
   ml_cstr(pgm, pgmname, 80);
   ml2_transfer_and_install := Cml2_transfer_and_install
      (pgm, usage, task, programnr, interruptnr, flag, datasize);
END;

PROCEDURE   ml2_install_task
            (task, programnr, interruptnr: WORD;
            flag, datasize, adr: LONGINT);
            EXTERNAL DLL_REF NAME 'ml8_install_task';

PROCEDURE   ml2_start_pgm;
            EXTERNAL DLL_REF NAME 'ml8_start_pgm';

FUNCTION    Cml2_transfer_pgm
            (task, usage: WORD; pgmname: PChar;
            VAR loadadr: LONGINT; VAR prepadr: LONGINT;
            VAR flag: LONGINT): WORD;
            EXTERNAL DLL_REF NAME 'ml8_transfer_pgm';

FUNCTION    ml2_transfer_pgm
            (task, usage: WORD; pgmname: str80;
            VAR loadadr: LONGINT; VAR prepadr: LONGINT;
            VAR flag: LONGINT): WORD;
VAR   pgm   :  ARRAY [0..80] OF CHAR;
BEGIN
   ml_cstr(pgm, pgmname, 80);
   ml2_transfer_pgm := Cml2_transfer_pgm
      (task, usage, pgm, loadadr, prepadr, flag);
END;

FUNCTION    Cml2_enable_remote_debug
            (task: WORD; pgmname: PChar; loadadr, prepadr: LONGINT): WORD;
            EXTERNAL DLL_REF NAME 'ml8_enable_remote_debug';

FUNCTION    ml2_enable_remote_debug
            (task: WORD; pgmname: str80; loadadr, prepadr: LONGINT): WORD;
VAR   pgm   :  ARRAY [0..80] OF CHAR;
BEGIN
   ml_cstr(pgm, pgmname, 80);
   ml2_enable_remote_debug := Cml2_enable_remote_debug(task, pgm, loadadr, prepadr);
END;

FUNCTION    ml2_send_macro (CB, format: BYTE; n, m: WORD; VAR b; VAR a): WORD;
            EXTERNAL DLL_REF NAME 'ml8_send_macro';

{ ***** INTERRUPT HANDLING / SERVICE REQUESTS ***** }

PROCEDURE   ml2_set_service
            (ml2_servProc: POINTER);
            EXTERNAL DLL_REF NAME 'ml8_set_service';

PROCEDURE   ml2_suspend_requests;
            EXTERNAL DLL_REF NAME 'ml8_suspend_requests';

PROCEDURE   ml2_allow_requests;
            EXTERNAL DLL_REF NAME 'ml8_allow_requests';

PROCEDURE   ml2_set_macro_interruptible
            (on_off: BOOLEAN);
            EXTERNAL DLL_REF NAME 'ml8_set_macro_interruptible';

FUNCTION    ml2_message_available: BOOLEAN;
            EXTERNAL DLL_REF NAME 'ml8_message_available';

FUNCTION    ml2_poll_request: BOOLEAN;
            EXTERNAL DLL_REF NAME 'ml8_poll_request';

FUNCTION    ml2_get_message: WORD;
            EXTERNAL DLL_REF NAME 'ml8_get_message';

{ ***** ERROR HANDLING ***** }

PROCEDURE   ml2_set_error_handling
            (error_handling_proc: POINTER);
            EXTERNAL DLL_REF NAME 'ml8_set_error_handling';

PROCEDURE   Cml2_get_error_info
            (VAR err_rec: ml2_error_info_type);
            EXTERNAL DLL_REF NAME 'ml8_get_error_info';

PROCEDURE   ml2_get_error_info(VAR err_rec: ml2_error_info_type);
VAR   markmsg  :  str80;
      errmsg   :  str80;
      hlp      :  PChar;
BEGIN
   Cml2_get_error_info(err_rec);
   hlp := @err_rec.errormessage[0];
   ml_pstr(errmsg, hlp, 80);
   hlp := @err_rec.markmessage[0];
   ml_pstr(markmsg, hlp, 80);
   err_rec.markmessage  := markmsg;
   err_rec.errormessage := errmsg;
END;

PROCEDURE   ml2_get_error_class_and_code
            (VAR error_class: BYTE; VAR error_code: BYTE);
            EXTERNAL DLL_REF NAME 'ml8_get_error_class_and_code';

FUNCTION    ml2_watch_error
            (usInfoType: WORD): LONGINT;
            EXTERNAL DLL_REF NAME 'ml8_watch_error';

PROCEDURE   ml2_call_user_error;
            EXTERNAL DLL_REF NAME 'ml8_call_user_error';

PROCEDURE   Cml2_make_err_msg(s: PChar; errclass, errcode: BYTE);
            EXTERNAL DLL_REF NAME 'ml8_make_err_msg';

PROCEDURE   ml2_make_err_msg
            (VAR s:str80; errclass, errcode: BYTE);
VAR   strg  :  ARRAY [0..80] OF CHAR;
BEGIN
   ml_cstr(strg, s, 80);
   Cml2_make_err_msg(strg, errclass, errcode);
END;

PROCEDURE   ml2_clear_error;
            EXTERNAL DLL_REF NAME 'ml8_clear_error';

PROCEDURE   ml2_set_max_error_retry
            (max: WORD);
            EXTERNAL DLL_REF NAME 'ml8_set_max_error_retry';

FUNCTION    ml2_error_repeat_test: BOOLEAN;
            EXTERNAL DLL_REF NAME 'ml8_error_repeat_test';

PROCEDURE   ml2_set_repeat_macro
            (rpm: BOOLEAN);
            EXTERNAL DLL_REF NAME 'ml8_set_repeat_macro';

FUNCTION    ml2_clear: WORD;
            EXTERNAL DLL_REF NAME 'ml8_clear';

PROCEDURE   ml2_set_mark
            (mark: WORD);
            EXTERNAL DLL_REF NAME 'ml8_set_mark';

FUNCTION    ml2_get_mark: WORD;
            EXTERNAL DLL_REF NAME 'ml8_get_mark';

PROCEDURE   Cml2_set_error_message
            (errormessage: PChar);
            EXTERNAL DLL_REF NAME 'ml8_set_error_message';

PROCEDURE   ml2_set_error_message
            (VAR errormessage: str80);
            VAR msg: ARRAY [0..80] OF CHAR;
BEGIN
   ml_cstr(msg, errormessage, 80);
   Cml2_set_error_message(msg);
END;

PROCEDURE   Cml2_get_error_message
            (errormessage: PChar);
            EXTERNAL DLL_REF NAME 'ml8_get_error_message';

PROCEDURE   ml2_get_error_message
            (VAR errormessage: str80);
            VAR msg: ARRAY [0..80] OF CHAR;
BEGIN
   Cml2_get_error_message(msg);
   ml_pstr(errormessage, msg, 80);
END;

PROCEDURE   Cml2_set_mark_message
            (markmessage: PChar);
            EXTERNAL DLL_REF NAME 'ml8_set_mark_message';

PROCEDURE   ml2_set_mark_message
            (VAR markmessage: str80);
            VAR msg: ARRAY [0..80] OF CHAR;
BEGIN
   ml_cstr(msg, markmessage, 80);
   Cml2_set_mark_message(msg);
END;

PROCEDURE   Cml2_get_mark_message
            (markmessage: PChar);
            EXTERNAL DLL_REF NAME 'ml8_get_mark_message';

PROCEDURE   ml2_get_mark_message
            (VAR markmessage: str80);
VAR msg: ARRAY [0..80] OF CHAR;
BEGIN
   Cml2_get_mark_message(msg);
   ml_pstr(markmessage, msg, 80);
END;




{ ***** COMMUNICATION CHECK ***** }

FUNCTION    ml2_reacting: BOOLEAN;
            EXTERNAL DLL_REF NAME 'ml8_reacting';

FUNCTION    ml2_type_check: BYTE;
            EXTERNAL DLL_REF;

FUNCTION    ml2_prog_in_rom
            (pgm: WORD): BOOLEAN;
            EXTERNAL DLL_REF NAME 'ml8_prog_in_rom';
{
PROCEDURE   ml2_reset_dlp;
            EXTERNAL DLL_REF NAME 'ml8_reset_dlp';

PROCEDURE   ml2_set_dlp;
            EXTERNAL DLL_REF NAME 'ml8_set_dlp';
}



{ ***** READ/WRITE RAM ***** }

PROCEDURE   ml2_set_ram_pointer
            (adr: LONGINT);
            EXTERNAL DLL_REF NAME 'ml8_set_ram_pointer';

PROCEDURE   ml2_read_ram
            (size: WORD; VAR data_var);
            EXTERNAL DLL_REF NAME 'ml8_read_ram';

PROCEDURE   ml2_write_ram
            (size: WORD; VAR data_var);
            EXTERNAL DLL_REF NAME 'ml8_write_ram';

{ ***** PORT I/O ***** }

FUNCTION    ml2_in8_port
            (port: WORD): BYTE;
            EXTERNAL DLL_REF NAME 'ml8_in8_port';

FUNCTION    ml2_in16_port
            (port: WORD): WORD;
            EXTERNAL DLL_REF NAME 'ml8_in16_port';

PROCEDURE   ml2_out8_port
            (port: WORD; data_var: BYTE);
            EXTERNAL DLL_REF NAME 'ml8_out8_port';

PROCEDURE   ml2_out16_port
            (port: WORD; data_var: WORD);
            EXTERNAL DLL_REF NAME 'ml8_out16_port';

{ ***** READ/WRITE EEPROM ***** }

FUNCTION    ml2_read_eeprom_direct
            (modul, reladr: BYTE): WORD;
            EXTERNAL DLL_REF NAME 'ml8_read_eeprom_direct';

FUNCTION    ml2_read_eeprom_copy
            (modul, reladr: BYTE): WORD;
            EXTERNAL DLL_REF NAME 'ml8_read_eeprom_copy';

PROCEDURE   ml2_write_eeprom_direct
            (modul, reladr: BYTE; data_var: WORD);
            EXTERNAL DLL_REF NAME 'ml8_write_eeprom_direct';

PROCEDURE   ml2_write_eeprom_copy
            (modul, reladr: BYTE; data_var: WORD);
            EXTERNAL DLL_REF NAME 'ml8_write_eeprom_copy';

{ ***** LED CONTROL ***** }

PROCEDURE   ml2_led_on;
            EXTERNAL DLL_REF NAME 'ml8_local_led_on';

PROCEDURE   ml2_led_off;
            EXTERNAL DLL_REF NAME 'ml8_local_led_off';

FUNCTION    ml2_get_led_status: BYTE;
            EXTERNAL DLL_REF NAME 'ml8_get_local_led_status';

{ ***** TASK/PROGRAM INFORMATION ***** }

FUNCTION    ml2_get_task_status
            (task: WORD): BYTE;
            EXTERNAL DLL_REF NAME 'ml8_get_task_status';

PROCEDURE   ml2_get_task_info
            (task: WORD; callnr: WORD; VAR result: LONGINT);
            EXTERNAL DLL_REF NAME 'ml8_get_task_info';

PROCEDURE   ml2_get_int_task
            (inter: WORD; VAR task: WORD; VAR dummy: BYTE);
            EXTERNAL DLL_REF;

FUNCTION    ml2_get_task_number
            (prognumber: WORD; VAR installnr: WORD): WORD;
            EXTERNAL DLL_REF;

FUNCTION    ml2_get_pgm_installed
            (task: WORD): WORD;
            EXTERNAL DLL_REF NAME 'ml8_get_pgm_installed';

{ ***** TASK CONTROL ***** }

PROCEDURE   ml2_wakeup_task
            (task: WORD);
            EXTERNAL DLL_REF NAME 'ml8_wakeup_task';

PROCEDURE   ml2_sleep_task
            (task: WORD);
            EXTERNAL DLL_REF NAME 'ml8_sleep_task';

{ ***** CALL PROCEDURE/FUNCTION OF A TASK ***** }

PROCEDURE   ml2_call_proc
            (task, procedurenr: WORD);
            EXTERNAL DLL_REF NAME 'ml8_call_proc';

PROCEDURE   ml2_call_func
            (task, func ,outsize: WORD; VAR outdata_var;
            maxinsize: WORD; VAR insize: WORD; VAR indata_var;
            VAR error: BYTE);
            EXTERNAL DLL_REF NAME 'ml8_call_func';

{ ***** READ/WRITE PARAMETER OF A TASK ***** }

FUNCTION    ml2_read_par_byte
            (task, start: WORD): BYTE;
            EXTERNAL DLL_REF NAME 'ml8_read_par_byte';

FUNCTION    ml2_read_par_word
            (task, start: WORD): WORD;
            EXTERNAL DLL_REF NAME 'ml8_read_par_word';

PROCEDURE   ml2_read_par_dword
            (task, start: WORD; VAR datavar: LONGINT);
            EXTERNAL DLL_REF NAME 'ml8_read_par_dword';

PROCEDURE   ml2_read_par_block
            (task, start, size: WORD; VAR data_var);
            EXTERNAL DLL_REF NAME 'ml8_read_par_block';

PROCEDURE   ml2_write_par_byte
            (task, start: WORD; data:BYTE);
            EXTERNAL DLL_REF NAME 'ml8_write_par_byte';

PROCEDURE   ml2_write_par_word
            (task, start, data: WORD);
            EXTERNAL DLL_REF NAME 'ml8_write_par_word';

PROCEDURE   ml2_write_par_dword
            (task, start: WORD; datavar: LONGINT);
            EXTERNAL DLL_REF NAME 'ml8_write_par_dword';

PROCEDURE   ml2_write_par_block
            (task, start, size: WORD; VAR data_var);
            EXTERNAL DLL_REF NAME 'ml8_write_par_block';

{ ***** READ/WRITE DATA AREA OF A TASK ***** }

PROCEDURE   ml2_reset_r_pointer
            (task: WORD);
            EXTERNAL DLL_REF NAME 'ml8_reset_r_pointer';

PROCEDURE   ml2_move_r_pointer
            (task: WORD; offset: LONGINT);
            EXTERNAL DLL_REF NAME 'ml8_move_r_pointer';

FUNCTION    ml2_read_data_byte
            (task: WORD): BYTE;
            EXTERNAL DLL_REF NAME 'ml8_read_data_byte';

FUNCTION    ml2_read_data_word
            (task: WORD): WORD;
            EXTERNAL DLL_REF NAME 'ml8_read_data_word';

PROCEDURE   ml2_read_data_dword
            (task: WORD; VAR datavar: LONGINT);
            EXTERNAL DLL_REF NAME 'ml8_read_data_dword';

PROCEDURE   ml2_read_data_block
            (task, size: WORD; VAR data_var);
            EXTERNAL DLL_REF NAME 'ml8_read_data_block';

PROCEDURE   ml2_reset_w_pointer
            (task: WORD);
            EXTERNAL DLL_REF NAME 'ml8_reset_w_pointer';

PROCEDURE   ml2_move_w_pointer
            (task: WORD; offset: LONGINT);
            EXTERNAL DLL_REF NAME 'ml8_move_w_pointer';

PROCEDURE   ml2_write_data_byte
            (task: WORD; data: BYTE);
            EXTERNAL DLL_REF NAME 'ml8_write_data_byte';

PROCEDURE   ml2_write_data_word
            (task, data: WORD);
            EXTERNAL DLL_REF NAME 'ml8_write_data_word';

PROCEDURE   ml2_write_data_dword
            (task: WORD; datavar: LONGINT);
            EXTERNAL DLL_REF NAME 'ml8_write_data_dword';

PROCEDURE   ml2_write_data_block
            (task, size: WORD; VAR data_var);
            EXTERNAL DLL_REF NAME 'ml8_write_data_block';


{ ***** MEMORY ALLOCATION ***** }

PROCEDURE   ml2_allocate_ram
            (task, usage: WORD; strategy, align: BYTE;
            VAR size: LONGINT; VAR adr: LONGINT);
            EXTERNAL DLL_REF NAME 'ml8_allocate_ram';

PROCEDURE   ml2_get_free_ram_size
            (align: BYTE; VAR size: LONGINT);
            EXTERNAL DLL_REF NAME 'ml8_get_free_ram_size';


{ ***** VERSION, DATE AND TIME CODES ***** }

PROCEDURE   Cml2_create_version_string
            (pacVerStr: PChar; ulVerCode: LONGINT);
            EXTERNAL DLL_REF NAME 'ml8_create_version_string';

PROCEDURE   ml2_create_version_string
            (VAR pacVerStr: str80; ulVerCode: LONGINT);
VAR   ver   :  ARRAY [0..20] OF CHAR;
BEGIN
   Cml2_create_version_string(ver, ulVerCode);
   ml_pstr(pacVerStr, ver, 20);
END;

PROCEDURE   Cml2_create_date_string
            (pacDateStr: PChar; ulDateCode: LONGINT);
            EXTERNAL DLL_REF NAME 'ml8_create_date_string';

PROCEDURE   ml2_create_date_string
            (VAR pacDateStr: str80; ulDateCode: LONGINT);
VAR   date  :  ARRAY [0..20] OF CHAR;
BEGIN
   Cml2_create_date_string(date, ulDateCode);
   ml_pstr(pacDateStr, date, 20);
END;

PROCEDURE   Cml2_create_time_string
            (pacTimeStr: PChar; ulTimeCode: LONGINT);
            EXTERNAL DLL_REF NAME 'ml8_create_time_string';

PROCEDURE   ml2_create_time_string
            (VAR pacTimeStr: str80; ulTimeCode: LONGINT);
VAR   time  :  ARRAY [0..20] OF CHAR;
BEGIN
   Cml2_create_time_string(time, ulTimeCode);
   ml_pstr(pacTimeStr, time, 20);
END;

PROCEDURE   Cml2_create_micro_time_string
            (pacTimeStr: PChar; VAR prcTimeCode: MICRO_TIME_CODE);
            EXTERNAL DLL_REF NAME 'ml8_create_micro_time_string';

PROCEDURE   ml2_create_micro_time_string
            (VAR pacTimeStr: str80; VAR prcTimeCode: MICRO_TIME_CODE);
VAR   time  :  ARRAY [0..20] OF CHAR;
BEGIN
   Cml2_create_micro_time_string(time, prcTimeCode);
   ml_pstr(pacTimeStr, time, 20);
END;


{ ***** SPECIAL FUNCTIONS ***** }

FUNCTION    ml2_get_exe_size (VAR Name: String; VAR Size: LongInt):
            Word;
            EXTERNAL DLL_REF;



{ ***** MDD FUNCTIONS ***** }


PROCEDURE   mdd2_get_version
            (usMDD: WORD; VAR pulVersion: LONGINT;
            VAR pulDate: LONGINT);
            EXTERNAL DLL_REF NAME 'mdd8_get_version'

FUNCTION    mdd2_open_channel
            (usMDD, usStrucSize: WORD; VAR pCPS): HMDD2;
            EXTERNAL DLL_REF NAME 'mdd8_open_channel'

PROCEDURE   Cmdd2_read_infotext
            (usMDD, usTxtNr: WORD; ucMaxLen: BYTE;
            pacInfotext: PChar);
            EXTERNAL DLL_REF NAME 'mdd8_read_infotext';

PROCEDURE   mdd2_read_infotext
            (usMDD, usTxtNr: WORD; ucMaxLen: BYTE;
            VAR pacInfotext: str80);
VAR   acTextFromMDD  :  ARRAY [0..80] OF CHAR;
BEGIN
   Cmdd2_read_infotext(usMDD, usTxtNr, ucMaxLen, acTextFromMDD);
   ml_pstr(pacInfotext, acTextFromMDD, 80);
END;

FUNCTION    mdd2_get_device_status
            (usMDD, usDevice, usIndex, usExtIndex: WORD): WORD;
            EXTERNAL DLL_REF NAME 'mdd8_get_device_status'

FUNCTION    mdd2_scan_channel
            (usMDD, usInfoType: WORD; hChannel: HMDD2;
            usCount: WORD; VAR pInfoData): WORD;
            EXTERNAL DLL_REF NAME 'mdd8_scan_channel'

PROCEDURE   mdd2_reset_driver
            (usMDD: WORD);
            EXTERNAL DLL_REF NAME 'mdd8_reset_driver'

PROCEDURE   mdd2_write_channel_byte
            (hChannel: HMDD2; ucData: BYTE);
            EXTERNAL DLL_REF NAME 'mdd8_write_channel_byte'

PROCEDURE   mdd2_write_channel_word
            (hChannel: HMDD2; usData: WORD);
            EXTERNAL DLL_REF NAME 'mdd8_write_channel_word'

PROCEDURE   mdd2_write_channel_dword
            (hChannel: HMDD2; ulData: LONGINT);
            EXTERNAL DLL_REF NAME 'mdd8_write_channel_dword'

PROCEDURE   mdd2_write_channel_short
            (hChannel: HMDD2; sData: INTEGER);
            EXTERNAL DLL_REF NAME 'mdd8_write_channel_short'

FUNCTION    mdd2_write_channel_block
            (hChannel: HMDD2; usCount: WORD; VAR pData): WORD;
            EXTERNAL DLL_REF NAME 'mdd8_write_channel_block'

PROCEDURE   mdd2_trigger_channel
            (hChannel: HMDD2);
            EXTERNAL DLL_REF NAME 'mdd8_trigger_channel'

FUNCTION    mdd2_read_channel_byte
            (hChannel: HMDD2): BYTE;
            EXTERNAL DLL_REF NAME 'mdd8_read_channel_byte'

FUNCTION    mdd2_read_channel_word
            (hChannel: HMDD2): WORD;
            EXTERNAL DLL_REF NAME 'mdd8_read_channel_word'

FUNCTION    mdd2_read_channel_dword
            (hChannel: HMDD2): DWORD;
            EXTERNAL DLL_REF NAME 'mdd8_read_channel_dword'

FUNCTION    mdd2_read_channel_short
            (hChannel: HMDD2): INTEGER;
            EXTERNAL DLL_REF NAME 'mdd8_read_channel_short'

FUNCTION    mdd2_read_channel_block
            (hChannel: HMDD2; usCount: WORD; VAR pData): WORD;
            EXTERNAL DLL_REF NAME 'mdd8_read_channel_block'

PROCEDURE   mdd2_send_channel_command
            (hChannel: HMDD2; usCmd: WORD);
            EXTERNAL DLL_REF NAME 'mdd8_send_channel_command'

PROCEDURE   mdd2_send_channel_control
            (hChannel: HMDD2; usCtrl: WORD; ulCtrlData: LONGINT);
            EXTERNAL DLL_REF NAME 'mdd8_send_channel_control'

FUNCTION    mdd2_send_channel_control_block
            (hChannel: HMDD2; usCtrl, usSize: WORD;
            VAR pCtrlData): WORD;
            EXTERNAL DLL_REF NAME 'mdd8_send_channel_control_block'

FUNCTION    mdd2_get_channel_info
            (hChannel: HMDD2; usInfo: WORD): LONGINT;
            EXTERNAL DLL_REF NAME 'mdd8_get_channel_info'

FUNCTION    mdd2_get_channel_info_block
            (hChannel: HMDD2; usInfo, usSize: WORD;
            VAR pInfoData): WORD;
            EXTERNAL DLL_REF NAME 'mdd8_get_channel_info_block'

PROCEDURE   Cmdd2_set_channel_caption
            (hChannel: HMDD2; usLen: WORD; pcCaption: PChar);
            EXTERNAL DLL_REF NAME 'mdd8_set_channel_caption';

PROCEDURE   mdd2_set_channel_caption
            (hChannel: HMDD2; usLen: WORD; pcCaption: STRING);
VAR   acCaptionToChannel   :  ARRAY [0..80] OF CHAR;
BEGIN
   ml_cstr(acCaptionToChannel, pcCaption, 80);
   Cmdd2_set_channel_caption
      (hChannel, usLen + 1, acCaptionToChannel);
END;

PROCEDURE   Cmdd2_get_channel_caption
            (hChannel: HMDD2; usLen: WORD; pcCaption: PChar);
            EXTERNAL DLL_REF NAME 'mdd8_set_channel_caption';

PROCEDURE   mdd2_get_channel_caption
            (hChannel: HMDD2; usLen: WORD; VAR pcCaption: STRING);
VAR   acCaptionFromChannel :  ARRAY [0..80] OF CHAR;
BEGIN
   Cmdd2_get_channel_caption
      (hChannel, usLen + 1, acCaptionFromChannel);
   ml_pstr(pcCaption, acCaptionFromChannel, 80);
END;

PROCEDURE   mdd2_close_channel (VAR phChannel: HMDD2);
            EXTERNAL DLL_REF NAME 'mdd8_close_channel';

FUNCTION    mdd2_check_handle_valid (hChannel: HMDD2): WORD;
            EXTERNAL DLL_REF NAME 'mdd8_check_handle_valid';

FUNCTION    mdd2_get_diagnosis : WORD;
            EXTERNAL DLL_REF NAME 'mdd8_get_diagnosis';

FUNCTION    Cml2_set_search_path (pPath: STRING) : LONGINT;
            EXTERNAL DLL_REF NAME 'ml8_set_search_path';

FUNCTION    ml2_set_search_path (pPath: STRING) : LONGINT;
VAR   acPath   :  ARRAY [0..255] OF CHAR;
BEGIN
   ml_cstr(acPath, pPath, 255);
   ml2_set_search_path := Cml2_set_search_path (acPath);
END;

