{********************************************************************
*  This is the interface source file to build the libraries
*  for following platforms:
*
*  Board:               ML2 - Multi-LAB/2
*
*  Operating Systems:   Windows 95
*                       Windows NT
*
*  Author:              Dipl.-Ing. H.Doersam
*
*  Last Change:         21/07/98
*
*  Copyrights           SORCUS Computer GmbH 1997, 1998
*                       All rights reserved
*
********************************************************************}



{********************************************************************
*
*  Defines for Preprocessor:
*
*  _MLXW32_    To build the MLXW32 library (uses stdcall) for
*              Windows 95 and Windows NT and for all cards
*
********************************************************************}



{ ***** STARTING/ENDING OF AN APPLICATION ***** }

PROCEDURE   ml2_bib_startup
            (language: WORD);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    Cml2_reset
            (card, adr, mode, IRQ_channel, DMA_channel: WORD;
            error_handler: POINTER; OSName: PChar; timeout: WORD):
            WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    ml2_reset
            (card, adr, mode, IRQ_channel, DMA_channel: WORD;
            error_handler: POINTER; VAR OSName: str80;
            timeout: WORD): WORD;

FUNCTION    ml2_start
            (card, adr, mode, IRQ_channel, DMA_channel: WORD;
            error_handler: POINTER; timeout: WORD): WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_exit;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_exit_card
            (card: WORD);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

{ ***** VERSION MANAGEMENT ***** }

PROCEDURE   Cml2_get_bib_version
            (version: PChar);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_get_bib_version
            (VAR version: str80);

PROCEDURE   Cml2_get_os_version
            (version: PChar);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_get_os_version
            (VAR version: str80);

PROCEDURE   ml2_get_lib_version
            (VAR pulVersion: LONGINT; VAR pulDate: LONGINT);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_get_mlxdrv_version
            (VAR pulVersion: LONGINT; VAR pulDate: LONGINT);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_get_osx_version
            (VAR pulVersion: LONGINT; VAR pulDate: LONGINT);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

{ ***** CARD SELECTION ***** }

PROCEDURE   ml2_select_card
            (card: WORD);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    ml2_get_selected_card: WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

{ ***** CARD CHECK ***** }

PROCEDURE   ml2_card_check
            (VAR b1: BYTE; VAR b2: BYTE; VAR b3: BYTE);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_ga_version
            (VAR ic14, ic16, ic21: BYTE);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

{ ***** TIMEOUT CONTROL ***** }

PROCEDURE   ml2_auto_timeout;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    ml2_propose_timeout
            (tenthsec: WORD): WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}
{
PROCEDURE   ml2_set_timeout
            (timeout: WORD);
}
PROCEDURE   ml2_change_timeout
            (timeout: WORD);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    ml2_get_timeout: WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

{ ***** INSTALLING REAL TIME PROGRAMS ***** }

FUNCTION    Cml2_transfer_and_install
            (pgmname: PChar; usage, task, programnr,
            interruptnr: WORD; flag, datasize: LONGINT): WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    ml2_transfer_and_install
            (pgmname: str80; usage, task, programnr,
            interruptnr: WORD; flag, datasize: LONGINT): WORD;

PROCEDURE   ml2_install_task
            (task, programnr, interruptnr: WORD;
            flag, datasize, adr: LONGINT);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_start_pgm;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    Cml2_transfer_pgm
            (task, usage: WORD; pgmname: PChar;
            VAR loadadr: LONGINT; VAR prepadr: LONGINT;
            VAR flag: LONGINT): WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    ml2_transfer_pgm
            (task, usage: WORD; pgmname: str80;
            VAR loadadr: LONGINT; VAR prepadr: LONGINT;
            VAR flag: LONGINT): WORD;

FUNCTION    Cml2_enable_remote_debug
            (task: WORD; pgmname: PChar; loadadr, prepadr: LONGINT): WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    ml2_enable_remote_debug
            (task: WORD; pgmname: str80; loadadr, prepadr: LONGINT): WORD;

FUNCTION    ml2_send_macro (CB, format: BYTE; n, m: WORD; VAR b; VAR a): WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}


{ ***** INTERRUPT HANDLING / SERVICE REQUESTS ***** }

PROCEDURE   ml2_set_service
            (ml2_servProc: POINTER);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_suspend_requests;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_allow_requests;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_set_macro_interruptible
            (on_off: BOOLEAN);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    ml2_message_available: BOOLEAN;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    ml2_poll_request: BOOLEAN;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    ml2_get_message: WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}



{ ***** ERROR HANDLING ***** }

PROCEDURE   ml2_set_error_handling
            (error_handling_proc: POINTER);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   Cml2_get_error_info
            (VAR err_rec: ml2_error_info_type);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_get_error_info
            (VAR err_rec: ml2_error_info_type);

PROCEDURE   ml2_get_error_class_and_code
            (VAR error_class: BYTE; VAR error_code: BYTE);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    ml2_watch_error
            (usInfoType: WORD): LONGINT;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_call_user_error;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   Cml2_make_err_msg(s: PChar; errclass, errcode: BYTE);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_make_err_msg
            (VAR s:str80; errclass, errcode: BYTE);

PROCEDURE   ml2_clear_error;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_set_max_error_retry
            (max: WORD);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    ml2_error_repeat_test: BOOLEAN;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_set_repeat_macro
            (rpm: BOOLEAN);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    ml2_clear: WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_set_mark
            (mark: WORD);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    ml2_get_mark: WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   Cml2_set_error_message
            (errormessage: PChar);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_set_error_message
            (VAR errormessage: str80);

PROCEDURE   Cml2_get_error_message
            (errormessage: PChar);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_get_error_message
            (VAR errormessage: str80);

PROCEDURE   Cml2_set_mark_message
            (markmessage: PChar);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_set_mark_message
            (VAR markmessage: str80);

PROCEDURE   Cml2_get_mark_message
            (markmessage: PChar);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_get_mark_message
            (VAR markmessage: str80);

{ ***** COMMUNICATION CHECK ***** }

FUNCTION    ml2_reacting: BOOLEAN;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    ml2_type_check: BYTE;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    ml2_prog_in_rom
            (pgm: WORD): BOOLEAN;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}
{
PROCEDURE   ml2_reset_dlp;
PROCEDURE   ml2_set_dlp;
}

{ ***** READ/WRITE RAM ***** }

PROCEDURE   ml2_set_ram_pointer
            (adr: LONGINT);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_read_ram
            (size: WORD; VAR data_var);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_write_ram
            (size: WORD; VAR data_var);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

{ ***** PORT I/O ***** }

FUNCTION    ml2_in8_port
            (port: WORD): BYTE;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    ml2_in16_port
            (port: WORD): WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_out8_port
            (port: WORD; data_var: BYTE);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_out16_port
            (port: WORD; data_var: WORD);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

{ ***** READ/WRITE EEPROM ***** }

FUNCTION    ml2_read_eeprom_direct
            (modul, reladr: BYTE): WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    ml2_read_eeprom_copy
            (modul, reladr: BYTE): WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_write_eeprom_direct
            (modul, reladr: BYTE; data_var: WORD);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_write_eeprom_copy
            (modul, reladr: BYTE; data_var: WORD);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

{ ***** LED CONTROL ***** }

PROCEDURE   ml2_led_on;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_led_off;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    ml2_get_led_status: BYTE;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

{ ***** TASK/PROGRAM INFORMATION ***** }

FUNCTION    ml2_get_task_status
            (task: WORD): BYTE;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_get_task_info
            (task: WORD; callnr: WORD; VAR result: LONGINT);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_get_int_task
            (inter: WORD; VAR task: WORD; VAR dummy: BYTE);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    ml2_get_task_number
            (prognumber: WORD; VAR installnr:WORD): WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    ml2_get_pgm_installed
            (task: WORD): WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

{ ***** TASK CONTROL ***** }

PROCEDURE   ml2_wakeup_task
            (task: WORD);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_sleep_task
            (task: WORD);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

{ ***** CALL PROCEDURE/FUNCTION OF A TASK ***** }

PROCEDURE   ml2_call_proc
            (task, procedurenr: WORD);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_call_func
            (task, func ,outsize: WORD; VAR outdata_var;
            maxinsize: WORD; VAR insize: WORD; VAR indata_var;
            VAR error: BYTE);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

{ ***** READ/WRITE PARAMETER OF A TASK ***** }

FUNCTION    ml2_read_par_byte
            (task, start: WORD): BYTE;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    ml2_read_par_word
            (task, start: WORD): WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_read_par_dword
            (task, start: WORD; VAR datavar: LONGINT);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_read_par_block
            (task, start, size: WORD; VAR data_var);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_write_par_byte
            (task, start: WORD; data:BYTE);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_write_par_word
            (task, start, data: WORD);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_write_par_dword
            (task, start: WORD; datavar: LONGINT);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_write_par_block
            (task, start, size: WORD; VAR data_var);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

{ ***** READ/WRITE DATA AREA OF A TASK ***** }

PROCEDURE   ml2_reset_r_pointer
            (task: WORD);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_move_r_pointer
            (task: WORD; offset: LONGINT);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    ml2_read_data_byte
            (task: WORD): BYTE;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    ml2_read_data_word
            (task: WORD): WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_read_data_dword
            (task: WORD; VAR datavar: LONGINT);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_read_data_block
            (task, size: WORD; VAR data_var);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_reset_w_pointer
            (task: WORD);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_move_w_pointer
            (task: WORD; offset: LONGINT);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_write_data_byte
            (task: WORD; data: BYTE);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_write_data_word
            (task, data: WORD);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_write_data_dword
            (task: WORD; datavar: LONGINT);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_write_data_block
            (task, size: WORD; VAR data_var);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

{ ***** MEMORY ALLOCATION ***** }

PROCEDURE   ml2_allocate_ram
            (task, usage: WORD; strategy, align: BYTE;
            VAR size: LONGINT; VAR adr: LONGINT);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_get_free_ram_size
            (align: BYTE; VAR size: LONGINT);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

{ ***** VERSION, DATE AND TIME CODES ***** }

PROCEDURE   Cml2_create_version_string
            (pacVerStr: PChar; ulVerCode: LONGINT);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_create_version_string
            (VAR pacVerStr: str80; ulVerCode: LONGINT);

PROCEDURE   Cml2_create_date_string
            (pacDateStr: PChar; ulDateCode: LONGINT);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_create_date_string
            (VAR pacDateStr: str80; ulDateCode: LONGINT);

PROCEDURE   Cml2_create_time_string
            (pacTimeStr: PChar; ulTimeCode: LONGINT);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   ml2_create_time_string
            (VAR pacTimeStr: str80; ulTimeCode: LONGINT);

PROCEDURE   Cml2_create_micro_time_string
            (pacTimeStr: PChar; VAR prcTimeCode: MICRO_TIME_CODE);
            {$ifndef _MLXW32_} {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif} {$endif}

PROCEDURE   ml2_create_micro_time_string
            (VAR pacTimeStr: str80; VAR prcTimeCode: MICRO_TIME_CODE);



{ ***** SPECIAL FUNCTIONS ***** }

FUNCTION    ml2_get_exe_size (VAR name: STRING;
            VAR size: LONGINT): WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}



{***** DECLARATION OF MDD FUNCTIONS ***** }

PROCEDURE   mdd2_get_version
            (usMDD: WORD; VAR pulVersion: LONGINT;
            VAR pulDate: LONGINT);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    mdd2_open_channel
            (usMDD, usStrucSize: WORD; VAR pCPS): HMDD2;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   mdd2_read_infotext
            (usMDD, usTxtNr: WORD; ucMaxLen: BYTE;
            VAR pacInfotext: str80);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    mdd2_get_device_status
            (usMDD, usDevice, usIndex, usExtIndex: WORD): WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    mdd2_scan_channel
            (usMDD, usInfoType: WORD; hChannel: HMDD2;
            usCount: WORD; VAR pInfoData): WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   mdd2_reset_driver
            (usMDD: WORD);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   mdd2_write_channel_byte
            (hChannel: HMDD2; ucData: BYTE);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   mdd2_write_channel_word
            (hChannel: HMDD2; usData: WORD);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   mdd2_write_channel_dword
            (hChannel: HMDD2; ulData: LONGINT);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   mdd2_write_channel_short
            (hChannel: HMDD2; sData: INTEGER);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    mdd2_write_channel_block
            (hChannel: HMDD2; usCount: WORD; VAR pData): WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   mdd2_trigger_channel
            (hChannel: HMDD2);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    mdd2_read_channel_byte
            (hChannel: HMDD2): BYTE;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    mdd2_read_channel_word
            (hChannel: HMDD2): WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    mdd2_read_channel_dword
            (hChannel: HMDD2): DWORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    mdd2_read_channel_short
            (hChannel: HMDD2): INTEGER;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    mdd2_read_channel_block
            (hChannel: HMDD2; usCount: WORD; VAR pData): WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   mdd2_send_channel_command
            (hChannel: HMDD2; usCmd: WORD);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   mdd2_send_channel_control
            (hChannel: HMDD2; usCtrl: WORD; ulCtrlData: LONGINT);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    mdd2_send_channel_control_block
            (hChannel: HMDD2; usCtrl, usSize: WORD;
            VAR pCtrlData): WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    mdd2_get_channel_info
            (hChannel: HMDD2; usInfo: WORD): LONGINT;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    mdd2_get_channel_info_block
            (hChannel: HMDD2; usInfo, usSize: WORD;
            VAR pInfoData): WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   Cmdd2_set_channel_caption
            (hChannel: HMDD2; usLen: WORD; pcCaption: PChar);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   mdd2_set_channel_caption
            (hChannel: HMDD2; usLen: WORD; pcCaption: STRING);

PROCEDURE   Cmdd2_get_channel_caption
            (hChannel: HMDD2; usLen: WORD; pcCaption: PChar);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

PROCEDURE   mdd2_get_channel_caption
            (hChannel: HMDD2; usLen: WORD; VAR pcCaption: STRING);

PROCEDURE   mdd2_close_channel (VAR phChannel: HMDD2);
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    mdd2_check_handle_valid (hChannel: HMDD2): WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    mdd2_get_diagnosis : WORD;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    Cml2_set_search_path (pPath: STRING) : LONGINT;
            {$ifndef _MLXW32_} cdecl; {$else} stdcall; {$endif}

FUNCTION    ml2_set_search_path (pPath: STRING) : LONGINT;

